## mingw-w64-libvips-8.18.0-2.src.tar.zst

=== meson_options.txt ===
# core options

option('deprecated',
  type: 'boolean',
  value: true,
  description: 'Build deprecated components')

option('examples',
  type: 'boolean',
  value: true,
  description: 'Build example programs')

option('cplusplus',
  type: 'boolean',
  value: true,
  description: 'Build C++ API')

option('cpp-docs',
  type: 'boolean',
  value: false,
  description: 'Build C++ documentation (requires doxygen)')

option('docs',
  type: 'boolean',
  value: false,
  description: 'Build API reference and tools documentation (requires gi-docgen)')

option('modules',
  type: 'feature',
  value: 'enabled',
  description: 'Build dynamic modules')

option('introspection',
  type: 'feature',
  value: 'auto',
  description: 'Build GObject introspection data')

option('vapi',
  type: 'boolean',
  value: false,
  description: 'Build VAPI')

# External libraries

option('cfitsio',
  type: 'feature',
  value: 'auto',
  description: 'Build with cfitsio')

option('cgif',
  type: 'feature',
  value: 'auto',
  description: 'Build with cgif')

option('exif',
  type: 'feature',
  value: 'auto',
  description: 'Build with libexif')

option('fftw',
  type: 'feature',
  value: 'auto',
  description: 'Build with fftw3')

option('fontconfig',
  type: 'feature',
  value: 'auto',
  description: 'Build with fontconfig')

option('archive',
  type: 'feature',
  value: 'auto',
  description: 'Build with libarchive')

option('heif',
  type: 'feature',
  value: 'auto',
  description: 'Build with libheif')

option('heif-module',
  type: 'feature',
  value: 'auto',
  description: 'Build libheif as module')

option('imagequant',
  type: 'feature',
  value: 'auto',
  description: 'Build with imagequant')

option('jpeg',
  type: 'feature',
  value: 'auto',
  description: 'Build with jpeg')

option('uhdr',
  type: 'feature',
  value: 'auto',
  description: 'Build with libuhdr')

option('jpeg-xl',
  type: 'feature',
  value: 'auto',
  description: 'Build with libjxl')

option('jpeg-xl-module',
  type: 'feature',
  value: 'auto',
  description: 'Build libjxl as module')

option('lcms',
  type: 'feature',
  value: 'auto',
  description: 'Build with lcms2')

option('magick',
  type: 'feature',
  value: 'auto',
  description: 'Build with libMagic')

option('magick-package',
  type: 'string',
  value: 'MagickCore',
  description: 'ImageMagick package to build with')

option('magick-features',
  type: 'array',
  choices: ['load', 'save'],
  value: ['load', 'save'],
  description: 'Enable libMagic load or save capabilities')

option('magick-module',
  type: 'feature',
  value: 'auto',
  description: 'Build libMagic as module')

option('matio',
  type: 'feature',
  value: 'auto',
  description: 'Build with matio')

option('nifti',
  type: 'feature',
  value: 'auto',
  description: 'Build with nifti')

option('nifti-prefix-dir',
  type: 'string',
  value: '',
  description: 'Prefix where nifticlib is installed (optional)')

option('openexr',
  type: 'feature',
  value: 'auto',
  description: 'Build with OpenEXR')

option('openjpeg',
  type: 'feature',
  value: 'auto',
  description: 'Build with libopenjp2')

option('openslide',
  type: 'feature',
  value: 'auto',
  description: 'Build with OpenSlide')

option('openslide-module',
  type: 'feature',
  value: 'auto',
  description: 'Build OpenSlide as module')

option('highway',
  type: 'feature',
  value: 'auto',
  description: 'Build with highway')

option('orc',
  type: 'feature',
  value: 'auto',
  description: 'Build with orc-0.4')

option('pangocairo',
  type: 'feature',
  value: 'auto',
  description: 'Build with pangocairo')

option('pdfium',
  type: 'feature',
  value: 'auto',
  description: 'Build with pdfium')

option('png',
  type: 'feature',
  value: 'auto',
  description: 'Build with png')

option('poppler',
  type: 'feature',
  value: 'auto',
  description: 'Build with poppler')

option('poppler-module',
  type: 'feature',
  value: 'auto',
  description: 'Build poppler as module')

option('quantizr',
  type: 'feature',
  value: 'auto',
  description: 'Build with quantizr')

option('raw',
  type: 'feature',
  value: 'auto',
  description: 'Build with libraw')

option('rsvg',
  type: 'feature',
  value: 'auto',
  description: 'Build with rsvg')

option('spng',
  type: 'feature',
  value: 'auto',
  description: 'Build with spng')

option('tiff',
  type: 'feature',
  value: 'auto',
  description: 'Build with tiff')

option('webp',
  type: 'feature',
  value: 'auto',
  description: 'Build with libwebp')

option('zlib',
  type: 'feature',
  value: 'auto',
  description: 'Build with zlib')

# not external libraries, but we have options to disable them to reduce
# the potential attack surface

option('nsgif',
  type: 'boolean',
  value: true,
  description: 'Build with nsgif')

option('ppm',
  type: 'boolean',
  value: true,
  description: 'Build with ppm')

option('analyze',
  type: 'boolean',
  value: true,
  description: 'Build with analyze')

option('radiance',
  type: 'boolean',
  value: true,
  description: 'Build with radiance')

# fuzzing options

option('fuzzing_engine',
    type: 'combo',
    choices : ['none', 'libfuzzer', 'oss-fuzz'],
    value: 'none',
    description: 'Select the fuzzing engine')

option('fuzzer_ldflags',
    type: 'string',
    description: 'Extra LDFLAGS used during linking of fuzzing binaries')

=== PKGBUILD ===
# Maintainer: Lars Kanis <lars@greiz-reinsdorf.de>

_realname=libvips
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=8.18.0
pkgrel=2
pkgdesc="A fast image processing library with low memory needs (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://libvips.org/"
msys2_repository_url="https://github.com/libvips/libvips"
msys2_references=(
  'anitya: 5097'
  'gentoo: media-libs/vips'
  "cpe: cpe:2.3:a:libvips:libvips"
)
license=('spdx:LGPL-2.1-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-cfitsio"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-gettext-runtime"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         #"${MINGW_PACKAGE_PREFIX}-gobject-introspection-runtime"
         "${MINGW_PACKAGE_PREFIX}-highway"
         "${MINGW_PACKAGE_PREFIX}-lcms2"
         "${MINGW_PACKAGE_PREFIX}-libarchive"
         "${MINGW_PACKAGE_PREFIX}-libexif"
         "${MINGW_PACKAGE_PREFIX}-libimagequant"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libraw"
         "${MINGW_PACKAGE_PREFIX}-librsvg"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libultrahdr"
         "${MINGW_PACKAGE_PREFIX}-libwebp"
         "${MINGW_PACKAGE_PREFIX}-matio"
         "${MINGW_PACKAGE_PREFIX}-openexr"
         "${MINGW_PACKAGE_PREFIX}-openjpeg2"
         "${MINGW_PACKAGE_PREFIX}-pango"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-meson"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             #"${MINGW_PACKAGE_PREFIX}-gobject-introspection"
             "${MINGW_PACKAGE_PREFIX}-gtk-doc"
             "${MINGW_PACKAGE_PREFIX}-omp"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-libheif"
             "${MINGW_PACKAGE_PREFIX}-libjxl"
             "${MINGW_PACKAGE_PREFIX}-imagemagick"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-poppler")
optdepends=("${MINGW_PACKAGE_PREFIX}-libheif: for heif module"
             "${MINGW_PACKAGE_PREFIX}-libjxl: for jxl module"
             "${MINGW_PACKAGE_PREFIX}-imagemagick: for magick module"
             "${MINGW_PACKAGE_PREFIX}-openslide: for openslide module"
             "${MINGW_PACKAGE_PREFIX}-poppler: for poppler module")
source=("https://github.com/libvips/libvips/releases/download/v${pkgver}/vips-${pkgver}.tar.xz")
sha256sums=('b85ab92280c30d22f5c8fe2f68b809cddb7eaac437d8c33474475dac84ddc574')

prepare() {
  cd "${srcdir}/vips-${pkgver}"
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="--prefix=" \
    ${MINGW_PREFIX}/bin/meson.exe setup \
      --prefix="${MINGW_PREFIX}" \
      --wrap-mode=nodownload \
      --auto-features=enabled \
      --buildtype=plain \
      -Dintrospection=disabled \
      -Dcgif=disabled \
      -Dspng=disabled \
      -Dpdfium=disabled \
      -Dnifti=disabled \
      "../vips-${pkgver}"

  ${MINGW_PREFIX}/bin/meson.exe compile
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/meson.exe install

  shopt -s globstar
  rm "${pkgdir}"${MINGW_PREFIX}/**/vips-modules-*/*.dll.a
}
